c calculate the cross sections for different model inputs using outputs from ciconv
      program xsec
      implicit none
      double precision :: Lambda, la(6), invm(100), mu0
      double precision :: rpar, chid, chiu, mad, mau, scaf(9), scar(9)
      double precision :: loinf(100, 12), nloinf(100, 12)
      double precision :: lobi1(100, 18), lobi2(100, 8) 
      double precision :: nlobi1(100, 18), nlobi2(100, 8)
      double precision :: coe(10),loxsec(100),nloxsec(100) 
      integer :: nmass, nrap, i, j, k, l, pdfmember, ncall, tcall, ncount 
      character*100 :: iname, oname, zz, tag, pdfname

      open(unit=120, file="input", status="old", action="read")
      read(120, *) zz, Lambda
      read(120, *) zz, la(1)
      read(120, *) zz, la(3)
      read(120, *) zz, la(5)
      read(120, *) zz, la(2)
      read(120, *) zz, la(4)
      read(120, *) zz, la(6)
      close(120)
      call getarg(1, iname)
      call getarg(2, oname)
      iname=trim(adjustl(adjustr(iname)))
      oname=trim(adjustl(adjustr(oname)))
      tcall=0
      ncount=0


      open(unit=121, file=iname, status="old", action="read")

      read(121, *)  zz
      read(121, *)  pdfname, pdfmember 
      ncount=ncount+2

      do while(0.gt.-1)
      read(121, *, end=300)  zz
      ncount=ncount+1
      enddo

 300  close(121)

      tcall=ncount/68
      if((mod(ncount, 68).ne.0).or.(tcall.eq.0)) then
      print *, "wrong file!"
      stop
      endif

      open(unit=122, file=iname, status="old", action="read")
      open(unit=123, file=oname, status="unknown")
      write(123, *) pdfname, pdfmember
      write(123,'(A8,F10.2,A4)') "Lambda=", Lambda, "GeV"
      write(123,'(A14,6F8.3)') "cj/4pi(1-6) =", la

      do ncall=1, tcall 

      read(122, *)  zz
      read(122, *)  pdfname, pdfmember 
      read(122, *)  zz
      read(122, *)  chid, chiu, mad, mau, mu0 
      read(122, *)  zz

      do i=1, 9
      read(122, *) scaf(i), scar(i)
      read(122, *) loinf(i, 1:12) 
      read(122, *) lobi1(i, 1:18) 
      read(122, *) lobi2(i, 1:8) 
      read(122, *) nloinf(i, 1:12) 
      read(122, *) nlobi1(i, 1:18) 
      read(122, *) nlobi2(i, 1:8)

      rpar=dlog(Lambda/mu0)
      loxsec(i)=0.d0
      nloxsec(i)=0.d0

      do k=1, 6
      loxsec(i)=loxsec(i)+la(k)*(loinf(i, 2*(k-1)+1)
     -   +loinf(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**2
      nloxsec(i)=nloxsec(i)+la(k)*(nloinf(i, 2*(k-1)+1)
     -   +nloinf(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**2
      enddo

      coe=0.d0
      do k=1, 3
      coe(1+3*(k-1))=la(1+2*(k-1))*la(1+2*(k-1))
      coe(2+3*(k-1))=la(2+2*(k-1))*la(2+2*(k-1))
      coe(3+3*(k-1))=la(1+2*(k-1))*la(2+2*(k-1))
      enddo

      do k=1, 9
      loxsec(i)=loxsec(i)+coe(k)*(lobi1(i, 2*(k-1)+1)
     -   +lobi1(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**4
      nloxsec(i)=nloxsec(i)+coe(k)*(nlobi1(i, 2*(k-1)+1)
     -   +nlobi1(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**4
      enddo

      coe=0.d0
      coe(1)=la(1)*la(4)
      coe(2)=la(2)*la(4)
      coe(3)=la(5)*la(4)
      coe(4)=la(6)*la(4)
 
      do k=1, 4
      loxsec(i)=loxsec(i)+coe(k)*(lobi2(i, 2*(k-1)+1)
     -   +lobi2(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**4
      nloxsec(i)=nloxsec(i)+coe(k)*(nlobi2(i, 2*(k-1)+1)
     -   +nlobi2(i, 2*(k-1)+2)*rpar)/(Lambda/5000.d0)**4
      enddo

      enddo

      write(123, *)  "Bin information: chid, chiu, md, mu" 
      write(123, *)  chid, chiu, mad, mau 
      write(123, *)"muf,  mur,  LO xsec(pb),  NLO xsec(pb)" 
      do i=1, 9
      write(123, '(2F7.3,2ES12.3)') scaf(i), scar(i), loxsec(i), nloxsec(i) 
      enddo

      enddo

      close(122)
      close(123) 

      end program
