!======================subroutine for the integration of==============
!=========================the total cross section=====================

      subroutine mctotal(sigmatot, errortot)
c total cross sections
      implicit none
      double precision sigma22, sigma23, sigmatot
      double precision error22, error23, errortot
      character*100 zz
      include "var.inc"

      sigma22=0.d0
      sigma23=0.d0
      sigmatot=0.d0
      error22=0.d0
      error23=0.d0
      errortot=0.d0
      recalc=1

c initialize the applgrid
      call appinit

      call xsec22(sigma22, error22)  !JG

      if((mode.ne.'resum').and.(loop.eq.1).and.(RGE.eq.0).and.(ndiagnal.eq.1)) then
      tol=error22/2.d0
      call xsec23(sigma23, error23)
      endif

c summarize the applgrid
      call append(apwname)

      sigmatot=sigma22+sigma23
      errortot=dsqrt(error22**2+error23**2)

      end subroutine

      subroutine xsec22(totsec, toterror)
c 2->2 cross sections
      implicit none
      double precision totsec(1)
      double precision toterror(1)
      external cuba
      external intgr22
      include "var.inc"

      if((ang.eq.4).and.(mode.ne."resum").and.(loop.eq.1).and.(RGE.eq.0)) then
      maxeval=6*many/2
      else
      maxeval=many
      endif

      call cuba(intgr22,totsec,toterror,4,1,-1999)
      end subroutine

      subroutine xsec23(totsec, toterror)
c 2->3 cross sections
      implicit none
      double precision totsec(1)
      double precision toterror(1)
      external cuba
      external intgr23
      include "var.inc"

      maxeval=20*many

      call cuba(intgr23,totsec,toterror,6,1,-1999)
      end subroutine

!=====================================================================
!=====================================================================
      
      integer function intgr22(nd, xx, nc, totcross,userdata,wgt,it)
c integrand of the 2->2 process
      implicit none
      integer nd, nc
      integer i, j, k, njet, cutfactor
      integer it, itmax
      double precision wgt, QQ(3), xx(nd), totcross(nc)
      double precision jacob(3), maux, xxx, yyy, results, gaux, userdata
      double precision mup, mdown, x(nd), pcms(0:3,4), fwt, sumwt 
      double precision plab(0:3,4), paux(0:3,2), pjet(0:3,3)
      double precision beta, flux, zzz, totint, msq(3, 2, 0:1)
      double precision pdfsum(3, 2), inti(2, 2)
      double precision intp1(3, 2, 0:4), intp2(3, 2, 0:4)
      double precision intk1(3, 2, 0:4), intk2(3, 2, 0:4)
      include "var.inc"
      include "appl.inc"
      include "grid.inc"
c for parellel calculation
      character*100 paname, fname
      integer :: pid=0, preit
      save paname, pid, preit

      if((it.eq.1).and.(pid.eq.0)) then
      preit=1
      auxwt=0.d0
      sumwt=0.d0
      pid=getpid()
      write(paname, '("sub.",I5.5)') pid
      itmax=int((dsqrt((2.d0*nstart-nincrease)**2+8.d0*nincrease*maxeval)
     -  -(2.d0*nstart-nincrease))/(2.d0*nincrease))+1
      if(itmax.lt.2) then
      print *, "too few points!"
      stop
      endif
      endif

      if(it.ne.preit) then

      fname="wei.log"
      call readwgt(fname, fwt)
      wgtgrid=(sumwt*wgtgrid+fwt*auxwt)/(sumwt+fwt) 
      sumwt=sumwt+fwt
      auxwt=0.d0

      if(it.eq.itmax) then
      call appsum(paname)
      pid=0
      endif

      preit=it

      endif
c end of parellel setup

      jacob=1.d0
      results=0.d0
      totint=0.d0
      totcross=1.d0
      pdfsum=0.d0
      inti=0.d0
      intp1=0.d0
      intp2=0.d0
      intk1=0.d0
      intk2=0.d0
      x(1)=xx(1)
      x(2)=xx(2)
      x(3)=xx(3)
      x(4)=xx(4)
      zzz=x(4)*(1-1.d-7)

      if(ang.ne.4) then
      mdown=masscutd
      mup=masscutu
      else
      mdown=10.d0
      mup=sqrtS
      endif

      call generatemass(x(1), mdown, mup, maux, jacob(1))
      call generatephase2to1(x(2), maux, xxx, yyy, paux, jacob(1))

      beta=(xxx-yyy)/(xxx+yyy)
      flux=hbar_c2/2.d0/maux**2

      do i=0, 3
      pcms(i, 1)=paux(i, 1) 
      pcms(i, 2)=paux(i, 2)
      enddo 

      call generatephase1to2(0.25d0, x(3), maux, 0.d0, 0.d0, paux, jacob(1))

      do i=0, 3
      pcms(i, 3)=paux(i, 1) 
      pcms(i, 4)=paux(i, 2)
      enddo 

      call pboost(plab, pcms, beta, 4)
      call jetfind(2, plab, njet, pjet)
      call determinecut(njet, pjet, cutfactor, QQ)

      totint=0.d0

      if(cutfactor.ge.1) then

      jacob(1)=cutfactor*jacob(1)
      jacob(2)=jacob(1)
      jacob(3)=jacob(1)

      facscale=fscale*QQ(1)
      renscale=rscale*QQ(1)

      call setcoupl

      call setgpdf(xxx, yyy, pdfsum)

      call CI22(pcms, msq, -1)

      apwgt=0.d0
      apmuf=0.d0
      apmur=0.d0
      apitID=it
      appdfx=xxx
      appdfy=yyy
      apmuf(1)=facscale
      apmur(1)=renscale

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)+msq(i, j, 1)
      totint=totint+pdfsum(i, j)*gaux
      apwgt(j+2*(i-1), 1)=apwgt(j+2*(i-1), 1)+msq(i, j, max(0, loop-RGE))
      enddo
      enddo

      results=jacob(1)*flux*totint


      if((mode.ne.'resum').and.(loop.eq.1).and.(RGE.eq.0).and.(ndiagnal.eq.1)) then

      call intdipi(pcms, inti)
      do k=0, 4
      call intdipp(1, k, pcms, zzz, intp1(1, 1, k))
      call intdipk(1, k, pcms, zzz, intk1(1, 1, k))
      call intdipp(2, k, pcms, zzz, intp2(1, 1, k))
      call intdipk(2, k, pcms, zzz, intk2(1, 1, k))
      enddo

      totint=0.d0
      do i=1, 2
      do j=1, 2
      gaux=inti(i, j)+intp1(i, j, 0)+intp2(i, j, 0)
     -     +intk1(i, j, 0)+intk2(i, j, 0)
      totint=totint+pdfsum(i, j)*gaux
      apwgt(j+2*(i-1), 1)=apwgt(j+2*(i-1), 1)+gaux
      enddo
      enddo


      do i=1,3
      do j=1,2
      do k=2,4
      gaux=intp1(i, j, k)+intk1(i, j, k)+intp2(i, j, k)+intk2(i, j, k)
      totint=totint-pdfsum(i, j)*gaux
      apwgt(min(j+2*(i-1), 5), 1)=apwgt(min(j+2*(i-1), 5), 1)-gaux
      enddo
      enddo
      enddo

      apwgt=wgt*jacob(1)*flux*apwgt/(alfas**nfac)
      if(totint.ne.0.d0) call appfill 

      results=results+jacob(1)*flux*totint

      flux=hbar_c2/2.d0/maux**2/zzz

      if(zzz.gt.xxx) then

      call setgpdf(xxx/zzz, yyy, pdfsum)

      totint=0.d0

      apwgt=0.d0
      appdfx=xxx/zzz
      appdfy=yyy

      do i=1,3
      do j=1,2
      do k=1,4
      gaux=intp1(i, j, k)+intk1(i, j, k)
      totint=totint+pdfsum(i, j)*gaux
      apwgt(min(j+2*(i-1), 5), 1)=apwgt(min(j+2*(i-1), 5), 1)+gaux
      enddo
      enddo
      enddo

      apwgt=wgt*jacob(2)*flux*apwgt/(alfas**nfac)
      if(totint.ne.0.d0) call appfill 

      results=results+jacob(2)*flux*totint

      endif

      if(zzz.gt.yyy) then

      call setgpdf(xxx, yyy/zzz, pdfsum)

      totint=0.d0

      apwgt=0.d0
      appdfx=xxx
      appdfy=yyy/zzz

      do i=1,3
      do j=1,2
      do k=1,4
      gaux=intp2(i, j, k)+intk2(i, j, k)
      totint=totint+pdfsum(i, j)*gaux
      apwgt(min(j+2*(i-1), 5), 1)=apwgt(min(j+2*(i-1), 5), 1)+gaux
      enddo
      enddo
      enddo

      apwgt=wgt*jacob(3)*flux*apwgt/(alfas**nfac)
      if(totint.ne.0.d0) call appfill 

      results=results+jacob(3)*flux*totint

      endif

      else

      apwgt=wgt*jacob(1)*flux*apwgt/(alfas**nfac)
      if(totint.ne.0.d0) call appfill 

      endif

      endif

      if(((results.gt.0.d0).and.(results.lt.0.d0)).or.abs(results)>1.d100) then
         print *, "nan here"
         results=0.d0
      endif


      totcross(1)=results
      intgr22=1

      end function

!=====================================================================
!=====================================================================

      integer function intgr23(nd, xx, nc, totcross,userdata,wgt,it)
c integrand of the 2->3 process
      implicit none
      integer nd, nc
      integer i, j, njet
      integer it, itmax
      double precision wgt, xx(nd), totcross(nc), userdata
      double precision x(nd), jacob, maux1, maux2, xxx, yyy, results
      double precision mup1, mdown1, paux2(0:3,2)
      double precision pcms(0:3,5), plab(0:3,5),paux1(0:3,2),pjet(0:3,3)
      double precision beta, flux, mdown2 ,mup2
      double precision pmother(0:3), paux3(0:3,2), sumwt, fwt
      double precision totint, realint, subint, phasecontrol
      external realint, subint, phasecontrol
      include "var.inc"
      include "appl.inc"
      include "grid.inc"
c for parellel calculation
      character*100 paname, fname
      integer :: pid=0, preit
      save paname, pid, preit

      if((it.eq.1).and.(pid.eq.0)) then
      preit=1
      auxwt=0.d0
      sumwt=0.d0
      pid=getpid()
      write(paname, '("sub.x",I5.5)') pid
      itmax=int((dsqrt((2.d0*nstart-nincrease)**2+8.d0*nincrease*maxeval)
     -  -(2.d0*nstart-nincrease))/(2.d0*nincrease))+1
      if(itmax.lt.2) then
      print *, "too few points!"
      stop
      endif
      endif

      if(it.ne.preit) then

      fname="wei.log"
      call readwgt(fname, fwt)
      wgtgrid=(sumwt*wgtgrid+fwt*auxwt)/(sumwt+fwt) 
      sumwt=sumwt+fwt
      auxwt=0.d0

      if(it.eq.itmax) then
      call appsum(paname)
      pid=0
      endif

      preit=it

      endif
c end of parellel setup

      jacob=1.d0
      totint=0.d0
      totcross=0.d0
      results=0.d0
      x(1)=xx(1)
      x(2)=xx(2)
      x(3)=xx(3)
      x(4)=xx(4)
      x(5)=xx(5)
      x(6)=xx(6)

      if(ang.ne.4) then
      mdown2=10.d0
      mup2=sqrtS
      else
      mdown2=10.d0
      mup2=sqrtS
      endif

      call generatemass(x(2), mdown2, mup2, maux2, jacob)
      call generatephase2to1(x(3), maux2, xxx, yyy, paux1, jacob)

      mdown1=0.d0
      mup1=maux2

      call generatemass(x(1), mdown1, mup1, maux1, jacob)

      beta=(xxx-yyy)/(xxx+yyy)
      flux=hbar_c2/2.d0/maux2**2

      do i=0,3
      pcms(i, 1)=paux1(i, 1) 
      pcms(i, 2)=paux1(i, 2)
      enddo

      call generatephase1to2(0.25d0, x(4), maux2, maux1, 0.d0, paux1, jacob)
      
      do i=0,3
      pcms(i, 5)=paux1(i, 2) 
      enddo

      call generatephase1to2(x(5), x(6), maux1, 0.d0, 0.d0, paux2, jacob)
      call ptransform(paux3, paux2, paux1(0,1), 2)
      
      do i=0,3
      pcms(i, 3)=paux3(i, 1) 
      pcms(i, 4)=paux3(i, 2) 
      enddo

      if(phasecontrol(pcms).eq.1.d0) then 

      call pboost(plab, pcms, beta, 5)

      apwgt=0.d0
      apmuf=0.d0
      apmur=0.d0
      apNum=0
      appdfx=xxx
      appdfy=yyy

      totint=realint(xxx, yyy, plab)-subint(xxx, yyy, plab) 

      apwgt=wgt*jacob*flux*apwgt
      if(totint.ne.0.d0) call appfill 

      results=jacob*flux*totint

      endif  

      if(((results.gt.0.d0).and.(results.lt.0.d0)).or.abs(results)>1.d100) then
         print *, "nan here"
         results=0.d0
      endif

      totcross(1)=results
      intgr23=1

      end function

!=====================================================================
!=====================================================================

      double precision function phasecontrol(p)
c controlling the phase space not reaching extreme singular region
      implicit none
      double precision p(0:3,5),softcut,colcut
      double precision gdot,s12,s34,s35,s45
      double precision t52,t42,t32,t51,t41,t31
      external gdot
      include 'var.inc' 

      phasecontrol=1.d0
      s12=2.d0*gdot(p(0,1),p(0,2))
      s34=2.d0*gdot(p(0,3),p(0,4))
      s35=2.d0*gdot(p(0,3),p(0,5))
      s45=2.d0*gdot(p(0,4),p(0,5))
      t52=-2.d0*gdot(p(0,2),p(0,5))
      t42=-2.d0*gdot(p(0,2),p(0,4))
      t32=-2.d0*gdot(p(0,2),p(0,3))
      t51=-2.d0*gdot(p(0,1),p(0,5))
      t41=-2.d0*gdot(p(0,1),p(0,4))
      t31=-2.d0*gdot(p(0,1),p(0,3))

      softcut=1.d-4*dsqrt(s12)/2.d0
      colcut=1.d-6*s12

      if((p(0,5).lt.softcut)) then

      phasecontrol=0.d0
      return

      endif

      if((abs(t51).lt.colcut).or.(abs(t41).lt.colcut)
     -  .or.(abs(t31).lt.colcut)) then

      phasecontrol=0.d0
      return

      endif

      if((abs(t52).lt.colcut).or.(abs(t42).lt.colcut)
     -  .or.(abs(t32).lt.colcut)) then

      phasecontrol=0.d0
      return

      endif

      if((abs(s34).lt.colcut).or.(abs(s35).lt.colcut)
     -  .or.(abs(s45).lt.colcut)) then

      phasecontrol=0.d0
      return

      endif

      end function
!=====================================================================
!=====================================================================
