!=============subroutine for the jet reconstruction===================
!============and the apply of all the kinematic cuts==================
      subroutine setcut(ii, jj, kk)
c initializing all the kinematic inputs
      implicit none
      integer ii, jj, kk
      double precision avemass, avechi
      include "var.inc"

      Nscale=bin1(ii)
      masscutd=bin2(jj, 1)
      masscutu=bin2(jj, 2)
      chid=bin3(kk, 1)
      chiu=bin3(kk, 2)
      avemass=(masscutd+masscutu)/2.d0
      avechi=(chid+chiu)/2.d0
      if(ang.eq.1) then
      mu0=avemass/dsqrt(avechi+1.d0/avechi+2.d0)
      elseif(ang.eq.2) then
      mu0=avemass/dsqrt(dexp(2.d0*avechi)+1.d0/dexp(2.d0*avechi)+2.d0)
      elseif(ang.eq.3) then
      mu0=avemass/dsqrt(dexp(avechi)+1.d0/dexp(avechi)+2.d0)
      elseif(ang.eq.4) then
      mu0=avemass
      else
      print *, "wrong choice for second observable of bin!"
      stop
      endif 
      if(mode.ne.'resum') then
      Nscale=5000.d0
      endif

      end subroutine
!=====================================================================                    
!=====================================================================                    

      subroutine determinecut(njet, pjet, cutfactor, QQ)
c apply cuts on the reconstructed jets
      implicit none
      integer njet, i, cutfactor, cout
      double precision pjet(0:3, 3), gpt, geta, gmij, QQ(3)
      double precision e1, e2, e3, chi, gy
      external gpt, geta, gmij, gy
      include "var.inc"

      cutfactor=1
      QQ=0.d0

      call jettrigger(njet, pjet, cutfactor)


      if(cutfactor.eq.1) then

              if(ang.ne.4) then

              if(scalescheme.eq.0) then
              QQ(1)=(gpt(pjet(0, 1))+gpt(pjet(0, 2)))/2.d0
              else
              QQ(1)=gpt(pjet(0, 1))*dexp(0.3d0*abs(gy(pjet(0, 1))-gy(pjet(0, 2)))/2.d0)
              endif

              if((gmij(pjet(0, 1), pjet(0, 2)).lt.masscutd)
     -          .or.(gmij(pjet(0, 1), pjet(0, 2)).gt.masscutu)) then
              cutfactor=0
              return
              endif

              if(abs((gy(pjet(0, 1))+gy(pjet(0, 2)))/2.d0).gt.yb) then
              cutfactor=0
              return
              endif

              if(abs((gy(pjet(0, 1))-gy(pjet(0, 2)))/2.d0).gt.ys) then
              cutfactor=0
              return
              endif

              if((gpt(pjet(0, 1)).lt.ptadd1).or.(gpt(pjet(0, 2)).lt.ptadd2)) then
              cutfactor=0
              return
              endif

              if(ang.eq.1) then
              chi=dexp(abs(gy(pjet(0, 1))-gy(pjet(0, 2))))
              elseif(ang.eq.2) then
              chi=abs(gy(pjet(0, 1))-gy(pjet(0, 2)))/2.d0
              elseif(ang.eq.3) then
              chi=max(abs(gy(pjet(0, 1))), abs(gy(pjet(0, 2))))
              else
              print *, "wrong choice for second observable of bin!"
              stop
              endif

              if((chi.lt.chid).or.(chi.gt.chiu)) then
              cutfactor=0
              return
              endif

              else

              cout=-1
              do i=njet, 1, -1
              if((gpt(pjet(0, i)).gt.masscutd).and.(gpt(pjet(0, i)).lt.
     -             masscutu).and.((abs(gy(pjet(0, i))).gt.chid).and.
     -             (abs(gy(pjet(0, i))).lt.chiu))) then
              cout=cout+1
              QQ(cout+1)=gpt(pjet(0, i))
              endif
              enddo
              if((scalescheme.eq.1).and.(cout.ne.-1)) then
              do i=1, 3
              if((abs(gy(pjet(0, i))).gt.chid).and.
     -             (abs(gy(pjet(0, i))).lt.chiu)) then
              QQ(1)=gpt(pjet(0, i))
              goto 100
              endif
              enddo
  100         QQ(2)=0.d0
              QQ(3)=0.d0
              endif
              cutfactor=cutfactor+cout
              return

              endif
 
      endif

      end subroutine
!=====================================================================                    
      subroutine jettrigger(njet, pjet, cutfactor)
c apply the acceptance conditions on the reconstructed jets
      implicit none 
      double precision pjet(0:3, 3)
      double precision yy, pp, gy, gpt
      integer njet, i, j, nnew, cutfactor
      external gy, gpt
      include "var.inc"

      nnew=0

      do i=1, njet

      yy=abs(gy(pjet(0, i)))
      pp=gpt(pjet(0, i))

      if((abs(yy).lt.ycut).and.(pp.gt.ptcut)) then
      nnew=nnew+1
      do j=0, 3
      pjet(j, nnew)=pjet(j, i)
      enddo
      endif

      enddo
      
      njet=nnew
      do i=nnew+1, 3
      do j=0, 3
      pjet(j, i)=0.d0
      enddo
      enddo

      if(ang.ne.4) then
      if(njet.lt.2) cutfactor=0
      else 
      if(njet.lt.1) cutfactor=0
      endif

      end subroutine
!=====================================================================                    
      subroutine jetfind(n, p, njet, pjet)
c reconstruct jets from the partons using different jet algorithm
      implicit none
      integer n, njet, i, j, k
      double precision p(0:3, n+2), pjet(0:3, 3), gmij
      double precision porder(0:3), gpt, gdRij, r12, r13, r23
      external gpt, gdRij, gmij
      include "var.inc"

      do j=1, 3
      do i=0, 3
      pjet(i, j)=0.d0
      enddo
      enddo

      if(n.eq.2) then

      njet=2
      do i=0, 3
      pjet(i, 1)=p(i, 3)
      pjet(i, 2)=p(i, 4)
      enddo

      elseif(n.eq.3) then

      r12=gdRij(p(0, 3), p(0, 4))
      r13=gdRij(p(0, 3), p(0, 5))
      r23=gdRij(p(0, 4), p(0, 5))

      if(r12.lt.Rcut) then

      call recombine(pjet(0, 1), p(0, 3), p(0, 4))

      if(((gdRij(pjet(0, 1), p(0, 3)).lt.Rcone).and.
     -  (gdRij(pjet(0, 1), p(0, 4)).lt.Rcone)).or.(nres.eq.0)) then

      njet=2
      do i=0, 3
      pjet(i, 2)=p(i, 5)
      enddo

      if(gpt(pjet(0, 1)).lt.gpt(pjet(0, 2))) then
      do i=0, 3
      porder(i)=pjet(i, 1)
      pjet(i, 1)=pjet(i, 2)
      pjet(i, 2)=porder(i)
      enddo
      endif
      
      else
            
      njet=3

      endif

      elseif(r13.lt.Rcut) then

      call recombine(pjet(0, 1), p(0, 3), p(0, 5))

      if(((gdRij(pjet(0, 1), p(0, 3)).lt.Rcone).and.
     -  (gdRij(pjet(0, 1), p(0, 5)).lt.Rcone)).or.(nres.eq.0)) then

      njet=2
      do i=0, 3
      pjet(i, 2)=p(i, 4)
      enddo

      if(gpt(pjet(0, 1)).lt.gpt(pjet(0, 2))) then
      do i=0, 3
      porder(i)=pjet(i, 1)
      pjet(i, 1)=pjet(i, 2)
      pjet(i, 2)=porder(i)
      enddo
      endif
      
      else
            
      njet=3

      endif

      elseif(r23.lt.Rcut) then

      call recombine(pjet(0, 1), p(0, 4), p(0, 5))

      if(((gdRij(pjet(0, 1), p(0, 4)).lt.Rcone).and.
     -  (gdRij(pjet(0, 1), p(0, 5)).lt.Rcone)).or.(nres.eq.0)) then

      njet=2
      do i=0, 3
      pjet(i, 2)=p(i, 3)
      enddo

      if(gpt(pjet(0, 1)).lt.gpt(pjet(0, 2))) then
      do i=0, 3
      porder(i)=pjet(i, 1)
      pjet(i, 1)=pjet(i, 2)
      pjet(i, 2)=porder(i)
      enddo
      endif
      
      else
            
      njet=3

      endif

      else

      njet=3

      endif

      if(njet.eq.3) then

      do i=0, 3
      pjet(i, 1)=p(i, 3)
      pjet(i, 2)=p(i, 4)
      pjet(i, 3)=p(i, 5)
      enddo

      do i=1, 2
      do j=i+1, 3
      if(gpt(pjet(0, i)).lt.gpt(pjet(0, j))) then

         do k=0, 3
         porder(k)=pjet(k, i)
         pjet(k, i)=pjet(k, j)
         pjet(k, j)=porder(k)
         enddo

      endif
      enddo
      enddo
     
      endif

      else
        
        print *, "wrong jet number!"

      endif

      end subroutine


!=====================================================================
!=====================================================================                    
      subroutine recombine(po, p1, p2)
c setting the recombination scheme of the jets
      implicit none
      double precision p1(0:3), p2(0:3), po(0:3), phi1, phi2
      double precision geta, gpt, gphi, et, et1, et2, ceta, cphi
      external get, gpt, gphi
      include "var.inc"

      if(recscheme.eq.1) then

      et1=abs(gpt(p1))
      et2=abs(gpt(p2))
      et=et1+et2

      ceta=(et1*geta(p1)+et2*geta(p2))/et
      phi1=gphi(p1)
      phi2=gphi(p2)
      if(abs(phi1-phi2).lt.pi) then
          cphi=(et1*phi1+et2*phi2)/et
      else
          if(phi2.gt.phi1) then
          cphi=(et1*(phi1+2.d0*pi)+et2*phi2)/et
          else
          cphi=(et2*(phi2+2.d0*pi)+et1*phi1)/et
          endif
      endif

      po(0)=et/dsin(2.d0*datan(abs(exp(-ceta))))
      po(1)=et*dcos(cphi)
      po(2)=et*dsin(cphi)
      po(3)=et/dtan(2.d0*datan(abs(exp(-ceta))))

      elseif(recscheme.eq.2) then

      po(0)=p1(0)+p2(0)
      po(1)=p1(1)+p2(1)
      po(2)=p1(2)+p2(2)
      po(3)=p1(3)+p2(3)

      else

        print *, "wrong recombination scheme!"
        stop

      endif

      end subroutine


!=====================================================================
!=========auxiliary functions for the kinematic variables=============                    

      double precision function gphi(p)
c************************************************************************
c     Returns azimuthal angle phi of a particle
c************************************************************************
      implicit none
      double precision p(0:3)
      double precision denom,temp
      double precision pi
      parameter ( pi=3.1415926535897932385 )

      denom = dsqrt(p(1)**2 + p(2)**2)
      temp = max(-0.99999999d0, p(1) / denom)
      temp = min( 0.99999999d0, temp)
      if (p(2).ge.0d0)then
         gphi =  dacos(temp)
      else
         gphi = -dacos(temp) + 2d0*pi
      endif

      end

      double precision function gmij(P1,P2)
c************************************************************************
c     Invarient mass of 2 particles
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3)
      double precision sumdot
      external sumdot

      gmij = dsqrt(Sumdot(p1,p2,1d0))

      RETURN
      end function


      double precision function gpt(p)
c************************************************************************
c     Returns transverse momentum of particle
c************************************************************************
      IMPLICIT NONE
      double precision p(0:3)

      gpt = dsqrt(p(1)**2+p(2)**2)

      end function

       DOUBLE PRECISION  FUNCTION gcosth(p)
c************************************************************************
c     Returns the cosine of the angle between the particle and the +z axis
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)
      double precision pt,pm

      pm = dsqrt(p(3)**2+p(2)**2+p(1)**2)
      if (abs(pm-p(3)).ge.abs(1d-10*p(3)))then
         gcosth = p(3)/pm
      else
         gcosth = 1d0
      endif

      end

      double precision function gdot(p1,p2)
C****************************************************************************
C     4-Vector Dot product
C****************************************************************************
      implicit none
      double precision p1(0:3),p2(0:3)
      gdot=p1(0)*p2(0)-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)
      end function

      double precision function SumDot(P1,P2,dsign)
c************************************************************************
c     Invarient mass of 2 particles
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3),dsign
      integer i
      double precision ptot(0:3)
      double precision gdot
      external gdot

      do i=0,3
         ptot(i)=p1(i)+dsign*p2(i)
      enddo
      SumDot = gdot(ptot,ptot)

      RETURN
      END function

      DOUBLE PRECISION  FUNCTION geta(p)
c************************************************************************
c     Returns pseudo-rapidity of particle in the lab frame
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)
      double precision gcosth

      if (abs(gcosth(p)).lt.0.9999999999d0)then
         geta = -dlog(dtan(0.5d0*dacos(gcosth(p))))
      elseif (gcosth(p).ge.0.9999999999d0)then
         geta =  10d0
      else
         geta = -10d0
      endif

      end

      DOUBLE PRECISION  FUNCTION gy(p)
c************************************************************************
c     Returns rapidity of particle in the lab frame
c************************************************************************
      IMPLICIT NONE
      double precision  p(0:3)

      gy=0.5d0*dlog((p(0)+p(3))/(p(0)-p(3)))

      end

      double precision function gdRij(P1,P2)
c************************************************************************
c     Distance in eta,phi between two particles.
c************************************************************************
      IMPLICIT NONE
      double precision p1(0:3),p2(0:3)
      double precision gETA,gDELTA_PHI,R2,gy
      external geta,gdelta_phi,gy

      R2 = (gDELTA_PHI(P1,P2))**2+(gy(p1)-gy(p2))**2
      gdRij = dsqrt(R2)

      RETURN
      END

      double precision function gdelta_phi(p1,p2)
c************************************************************************
c     Returns separation in phi of two particles
c************************************************************************
      implicit none
      double precision p1(0:3),p2(0:3)
      REAL*8 DENOM, TEMP

      DENOM = SQRT(P1(1)**2 + P1(2)**2) * SQRT(P2(1)**2 + P2(2)**2)
      TEMP = MAX(-0.99999999D0, (P1(1)*P2(1) + P1(2)*P2(2)) / DENOM)
      TEMP = MIN( 0.99999999D0, TEMP)
      gDELTA_PHI = ACOS(TEMP)

      END

c************************************************************************      
