!====initialization subroutine for the reading========================
!====of the process parameters, kinematic parameters,=================
!====and the inputs of the calculated bins============================
      subroutine readvar
      implicit none
      character*100 file1, file2, file3

      file1='proinput.card'
      file2='kininput.card'
      file3='bininput.card'

      call proread(file1)
      call kinread(file2)
      call binread(file3)
 
      end subroutine

!=====================================================================
!=====================================================================
      subroutine proread(fil)
c reading basic process informations
      implicit none
      double precision yy
      character*100 fil, xx, zz
      integer i,j,n,ii
      include "var.inc"

      i=1
      j=0
      open(unit=127, file=fil, status='old', action='read')
      read(127,*) xx, zz
      pdfname=zz
      if(xx.ne.'pdf') then
      print *, 'wrong in proinput.card!' 
      print *, 'the first input parameter should be the pdfname!'
      stop
      endif 
      read(127,*) xx, ii
      pdfmember=ii
      if(xx.ne.'pdfmember') then
      print *, 'wrong in proinput.card!' 
      print *, 'the second input parameter should be the pdfmember!'
      stop
      endif 
      read(127,*) xx, zz
      mode=zz
      if(xx.ne.'mode') then
      print *, 'wrong in proinput.card!' 
      print *, 'the second input parameter should be the mode!'
      stop
      endif 
      Call SetLHAPARM('SILENT') 
      call InitPDFsetbyname(pdfname)
      call InitPDF(pdfmember)

      do while(i.eq.1)

      read(127,*,end=400) xx, yy
      
      if(xx.eq.'sqrtS') then
              sqrtS=yy
              j=j+1
      elseif(xx.eq.'scalescheme') then
              scalescheme=yy
              j=j+1
      elseif(xx.eq.'ppcollider') then
              ppcollider=yy
              j=j+1
      elseif(xx.eq.'many') then
              many=yy
              j=j+1
      elseif(xx.eq.'pseed') then
              pseed=yy
              j=j+1
      elseif(xx.eq.'ang') then
              ang=yy
              j=j+1
      endif

      enddo

400   close(127)

      scheme='TOT'
      gg=0.d0
      ndiagnal=1
      div=0.d0
      ncross=0
      nfac=0

      if(ppcollider.eq.1) then
              sig=1
      elseif(ppcollider.eq.0) then
              sig=-1
      else
              print *, "wrong collider!"
              stop
      endif
      
      if(j.ne.6) then
              print *, "wrong in proinput.card!"
              stop
      endif

      end subroutine

!=====================================================================
!=====================================================================
      subroutine kinread(fil)
c reading kinematic informations
      implicit none
      double precision yy
      character*100 fil, xx, zz
      integer i,j,n
      include "var.inc"

      i=1
      j=0
      open(unit=125, file=fil, status='old', action='read')


      do while(i.eq.1)

      read(125,*,end=400) xx, yy
      
      if(xx.eq.'jetscheme') then
              jetscheme=yy
              j=j+1
      elseif(xx.eq.'recscheme') then
              j=j+1
              recscheme=yy
      elseif(xx.eq.'Rcone') then
              j=j+1
              Rcone=yy
      elseif(xx.eq.'ycut') then
              j=j+1
              ycut=yy
      elseif(xx.eq.'ptcut') then
              j=j+1
              ptcut=yy
      elseif(xx.eq.'ptadd1') then
              j=j+1
              ptadd1=yy
      elseif(xx.eq.'ptadd2') then
              j=j+1
              ptadd2=yy
      elseif(xx.eq.'yb') then
              j=j+1
              yb=yy
      elseif(xx.eq.'Rsep') then
              j=j+1
              Rsep=yy
      elseif(xx.eq.'ys') then
              j=j+1
              ys=yy
      endif

      enddo

400   close(125)

      if(j.ne.10) then
              print *, "wrong in kininput.card!"
              stop
      endif

      if(jetscheme.eq.1) then
      Rcut=Rcone
      nres=0
      elseif(jetscheme.eq.2) then
      Rcut=Rsep*Rcone
      nres=1
      else
      print *, "Wrong jet scheme!"
      stop
      endif

      end subroutine

!=====================================================================
!=====================================================================
      subroutine binread(fil)
c reading information of the calculated bins
      implicit none
      integer i, j, k, n
      character*100 zz, fil
      include "var.inc"

      i=0
      j=0
      n=0
      open(unit=122, file=fil, status='old', action='read')

      do while(0.lt.1)
      read(122, *, end=300) zz
      n=n+1
      if(zz.eq.'massbin') i=n 
      if(zz.eq.'rapbin') j=n
      enddo

300   close(122)

      if((i.eq.0).or.(j.eq.0).or.(j.lt.(i+2)).or.(j.eq.n)) then
      print *, "wrong in bininput.card!"
      stop
      endif
      nbin1=1
      nbin2=j-i-1
      nbin3=n-j

      bin1(1)=5000.d0
 
      open(unit=123, file=fil, status='old', action='read')
      read(123, *) zz
      do k=1, nbin2
      read(123, *) bin2(k, 1), bin2(k, 2) 
      enddo
      read(123, *) zz
      do k=1, nbin3
      read(123, *) bin3(k, 1), bin3(k, 2) 
      enddo
      close(123)
 
      end subroutine
    
!=====================================================================
!=====================================================================
      subroutine setcoupl
c set the QCD and CI couplings
      implicit none
      double precision NC
      double precision alphasPDF, lg
      parameter (NC=3)
      external alphasPDF
      include "var.inc"

      alfas=alphasPDF(renscale)

      kappas=4.d0*pi*gs2/Nscale**2
      kappao=4.d0*pi*go2/Nscale**2

      end subroutine

      subroutine mykappa(ccc)
c  calculate running of the Wilson coefficients
      implicit none
      double precision ga(6), ke(6), alphasPDF, areomuf
      double precision ccc(6)
      integer n, i
      external alphasPDF
      include "var.inc"

      ga(1)=-0.942d0
      ga(2)=0.818d0
      ga(3)=-0.627d0
      ga(4)=0.265d0
      ga(5)=0.183d0
      ga(6)=-0.160d0

      areomuf=alphasPDF(renscale)/alphasPDF(Nscale)
      
      do i=1, 6
      ke(i)=areomuf**ga(i)
      enddo

        ccc(1)= kappao(2)*(0.034487232581204064*ke(1) + 
     -     0.04238686796933248*ke(2) - 0.04226892627109324*ke(5) - 
     -     0.03460517427944327*ke(6)) + 
     -  kappao(1)*(0.05599386706053035*ke(1) - 
     -     0.025423109604543807*ke(2) + 0.09742262540572309*ke(3) - 
     -     0.09742262540572309*ke(4) - 0.05324246474561681*ke(5) + 
     -     0.022671707289630277*ke(6)) + 
     -  kappao(3)*(0.05599386706053035*ke(1) - 
     -     0.025423109604543807*ke(2) - 0.09742262540572309*ke(3) + 
     -     0.09742262540572309*ke(4) - 0.05324246474561681*ke(5) + 
     -     0.022671707289630277*ke(6)) + 
     -  kappas(3)*(0.06319542151801154*ke(1) + 
     -     0.020707620948214295*ke(2) - 0.14851809853570508*ke(3) - 
     -     0.351481901464295*ke(4) + 0.3184177619965172*ke(5) + 
     -     0.09767919553725692*ke(6)) + 
     -  kappas(1)*(0.06319542151801154*ke(1) + 
     -     0.020707620948214295*ke(2) + 0.14851809853570508*ke(3) + 
     -     0.351481901464295*ke(4) + 0.3184177619965172*ke(5) + 
     -     0.09767919553725692*ke(6)) + 
     -  kappas(2)*(-0.028638803105578675*ke(1) + 
     -     0.04053551783572989*ke(2) - 0.18073962223393933*ke(5) + 
     -     0.16884290750378814*ke(6))

        ccc(2)= kappao(2)*(0.18688495571075953*ke(1) - 
     -     0.19945248080676792*ke(2) + 0.04448376884451756*ke(5) - 
     -     0.03191624374850911*ke(6)) + 
     -  kappao(3)*(0.3034285613100946*ke(1) + 
     -     0.11962908616218962*ke(2) - 0.3514819014642949*ke(3) - 
     -     0.14851809853570508*ke(4) + 0.056032307971733496*ke(5) + 
     -     0.020910044555982284*ke(6)) + 
     -  kappao(1)*(0.3034285613100946*ke(1) + 
     -     0.11962908616218962*ke(2) + 0.3514819014642949*ke(3) + 
     -     0.14851809853570508*ke(4) + 0.056032307971733496*ke(5) + 
     -     0.020910044555982284*ke(6)) + 
     -  kappas(1)*(0.34245350141411746*ke(1) - 
     -     0.0974402348556583*ke(2) + 0.5358244397314771*ke(3) - 
     -     0.5358244397314771*ke(4) - 0.33510248237198315*ke(5) + 
     -     0.09008921581352403*ke(6)) + 
     -  kappas(3)*(0.34245350141411746*ke(1) - 
     -     0.0974402348556583*ke(2) - 0.5358244397314771*ke(3) + 
     -     0.5358244397314771*ke(4) - 0.33510248237198315*ke(5) + 
     -     0.09008921581352403*ke(6)) + 
     -  kappas(2)*(-0.1551925466154168*ke(1) - 
     -     0.19074090586199632*ke(2) + 0.19021016821991862*ke(5) + 
     -     0.1557232842574945*ke(6))

         ccc(3)=kappao(2)*(-0.0426845722274312*ke(1) + 
     -     0.12704802402920687*ke(2) + 0.04712530710457397*ke(5) - 
     -     0.13148875890634967*ke(6)) + 
     -  kappao(1)*(-0.06930316189362802*ke(1) - 
     -     0.07620180482011933*ke(2) + 0.*ke(3) + 0.*ke(4) + 
     -     0.05935962238665947*ke(5) + 0.0861453443270879*ke(6)) + 
     -  kappao(3)*(-0.06930316189362802*ke(1) - 
     -     0.07620180482011933*ke(2) + 0.*ke(3) + 0.*ke(4) + 
     -     0.05935962238665947*ke(5) + 0.0861453443270879*ke(6)) + 
     -  kappas(1)*(-0.07821646830829432*ke(1) + 
     -     0.06206786322876946*ke(2) + 0.*ke(3) + 0.*ke(4) - 
     -     0.3550015613218678*ke(5) + 0.37115016640139264*ke(6)) + 
     -  kappas(3)*(-0.07821646830829432*ke(1) + 
     -     0.06206786322876946*ke(2) + 0.*ke(3) + 0.*ke(4) - 
     -     0.3550015613218678*ke(5) + 0.37115016640139264*ke(6)) + 
     -  kappas(2)*(0.03544601779191454*ke(1) + 
     -     0.12149889082996707*ke(2) + 0.20150524167830447*ke(5) + 
     -     0.641549849699814*ke(6))

         ccc(4)=kappas(2)*(-0.19208057502344084*ke(1) + 
     -     0.5717161081314316*ke(2) + 0.21206388197058193*ke(5) - 
     -     0.5916994150785727*ke(6)) + 
     -  kappas(1)*(0.42385196264238606*ke(1) + 
     -     0.2920619024814491*ke(2) + 0.*ke(3) + 0.*ke(4) - 
     -     0.37360323023119846*ke(5) - 0.3423106348926367*ke(6)) + 
     -  kappas(3)*(0.42385196264238606*ke(1) + 
     -     0.2920619024814491*ke(2) + 0.*ke(3) + 0.*ke(4) - 
     -     0.37360323023119846*ke(5) - 0.3423106348926367*ke(6)) + 
     -  kappao(1)*(0.37555110606831527*ke(1) - 
     -     0.3585695226248462*ke(2) + 0.*ke(3) + 0.*ke(4) + 
     -     0.06246999755827287*ke(5) - 0.07945158100174196*ke(6)) + 
     -  kappao(3)*(0.37555110606831527*ke(1) - 
     -     0.3585695226248462*ke(2) + 0.*ke(3) + 0.*ke(4) + 
     -     0.06246999755827287*ke(5) - 0.07945158100174196*ke(6)) + 
     -  kappao(2)*(0.2313060165518733*ke(1) + 
     -     0.5978276949492252*ke(2) + 0.04959461838519401*ke(5) + 
     -     0.12127167011370765*ke(6))

         ccc(5)=kappao(2)*(0.034487232581204064*ke(1) + 
     -     0.04238686796933248*ke(2) - 0.04226892627109324*ke(5) - 
     -     0.03460517427944327*ke(6)) + 
     -  kappao(3)*(0.05599386706053035*ke(1) - 
     -     0.025423109604543807*ke(2) + 0.09742262540572309*ke(3) - 
     -     0.09742262540572309*ke(4) - 0.05324246474561681*ke(5) + 
     -     0.022671707289630277*ke(6)) + 
     -  kappao(1)*(0.05599386706053035*ke(1) - 
     -     0.025423109604543807*ke(2) - 0.09742262540572309*ke(3) + 
     -     0.09742262540572309*ke(4) - 0.05324246474561681*ke(5) + 
     -     0.022671707289630277*ke(6)) + 
     -  kappas(1)*(0.06319542151801154*ke(1) + 
     -     0.020707620948214295*ke(2) - 0.14851809853570508*ke(3) - 
     -     0.351481901464295*ke(4) + 0.3184177619965172*ke(5) + 
     -     0.09767919553725692*ke(6)) + 
     -  kappas(3)*(0.06319542151801154*ke(1) + 
     -     0.020707620948214295*ke(2) + 0.14851809853570508*ke(3) + 
     -     0.351481901464295*ke(4) + 0.3184177619965172*ke(5) + 
     -     0.09767919553725692*ke(6)) + 
     -  kappas(2)*(-0.028638803105578675*ke(1) + 
     -     0.04053551783572989*ke(2) - 0.18073962223393933*ke(5) + 
     -     0.16884290750378814*ke(6))


        ccc(6)= kappao(2)*(0.18688495571075953*ke(1) - 
     -     0.19945248080676792*ke(2) + 0.04448376884451756*ke(5) - 
     -     0.03191624374850911*ke(6)) + 
     -  kappao(1)*(0.3034285613100946*ke(1) + 
     -     0.11962908616218962*ke(2) - 0.3514819014642949*ke(3) - 
     -     0.14851809853570508*ke(4) + 0.056032307971733496*ke(5) + 
     -     0.020910044555982284*ke(6)) + 
     -  kappao(3)*(0.3034285613100946*ke(1) + 
     -     0.11962908616218962*ke(2) + 0.3514819014642949*ke(3) + 
     -     0.14851809853570508*ke(4) + 0.056032307971733496*ke(5) + 
     -     0.020910044555982284*ke(6)) + 
     -  kappas(3)*(0.34245350141411746*ke(1) - 
     -     0.0974402348556583*ke(2) + 0.5358244397314771*ke(3) - 
     -     0.5358244397314771*ke(4) - 0.33510248237198315*ke(5) + 
     -     0.09008921581352403*ke(6)) + 
     -  kappas(1)*(0.34245350141411746*ke(1) - 
     -     0.0974402348556583*ke(2) - 0.5358244397314771*ke(3) + 
     -     0.5358244397314771*ke(4) - 0.33510248237198315*ke(5) + 
     -     0.09008921581352403*ke(6)) + 
     -  kappas(2)*(-0.1551925466154168*ke(1) - 
     -     0.19074090586199632*ke(2) + 0.19021016821991862*ke(5) + 
     -     0.1557232842574945*ke(6))

      end subroutine

