!=================calculation of the real subtraction terms in dipole formalism============
!==========================================================================================
      double precision function subint(xxx, yyy, p)
c  real subtraction terms in the dipole formalism, including 21 sub-terms
      implicit none
      integer i
      double precision p(0:3, 5), ans(21), xxx, yyy, aux

      aux=0.d0

      ans=0.d0

      call realdip001(p, ans(1), xxx, yyy) !JG

      call realdip002(p, ans(2), xxx, yyy)

      call realdip003(p, ans(3), xxx, yyy)

      call realdip004(p, ans(4), xxx, yyy)

      call realdip005(p, ans(5), xxx, yyy)

      call realdip006(p, ans(6), xxx, yyy)

      call realdip007(p, ans(7), xxx, yyy)

      call realdip008(p, ans(8), xxx, yyy)

      call realdip009(p, ans(9), xxx, yyy)

      call realdip010(p, ans(10), xxx, yyy)

      call realdip011(p, ans(11), xxx, yyy)

      call realdip012(p, ans(12), xxx, yyy)

      call realdip013(p, ans(13), xxx, yyy)

      call realdip014(p, ans(14), xxx, yyy)

      call realdip015(p, ans(15), xxx, yyy)

      call realdip016(p, ans(16), xxx, yyy)

      call realdip017(p, ans(17), xxx, yyy)

      call realdip018(p, ans(18), xxx, yyy)

      call realdip019(p, ans(19), xxx, yyy)

      call realdip020(p, ans(20), xxx, yyy)

      call realdip021(p, ans(21), xxx, yyy)

      do i=1, 21
      aux=aux+ans(i)
      enddo

      subint=aux

      end function


      subroutine realdip001(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p15
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(1, 5, 2, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)

      p15=gdot(p(0, 1), p(0, 5))
      call dipoleCI22(p1, msq, 1)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p15/x/CF*vv(4, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip002(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p15
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(1, 5, 3, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)

      p15=gdot(p(0, 1), p(0, 5))
      call dipoleCI22(p1, msq, 2)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p15/x/CF*vv(3, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip003(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p15
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(1, 5, 4, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p15=gdot(p(0, 1), p(0, 5))
      call dipoleCI22(p1, msq, 3)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p15/x/CF*vv(3, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip004(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 1)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p25/x/CF*vv(4, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip005(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 3, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 3)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p25/x/CF*vv(3, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip006(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 4, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 2)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p25/x/CF*vv(3, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip007(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p35
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(3, 5, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p35=gdot(p(0, 3), p(0, 5))
      call dipoleCI22(p1, msq, 2)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p35/x/CF*vv(2, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip008(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p35
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(3, 5, 2, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p35=gdot(p(0, 3), p(0, 5))
      call dipoleCI22(p1, msq, 3)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p35/x/CF*vv(2, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip009(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p35
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(3, 5, 4, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p35=gdot(p(0, 3), p(0, 5))
      call dipoleCI22(p1, msq, 1)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p35/CF*vv(1, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip010(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p45
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(4, 5, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p45=gdot(p(0, 4), p(0, 5))
      call dipoleCI22(p1, msq, 3)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p45/x/CF*vv(2, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip011(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p45
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(4, 5, 2, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p45=gdot(p(0, 4), p(0, 5))
      call dipoleCI22(p1, msq, 2)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p45/x/CF*vv(2, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip012(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p45
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(4, 5, 3, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p45=gdot(p(0, 4), p(0, 5))
      call dipoleCI22(p1, msq, 1)

      do i=1, 2
      do j=1, 2
      gaux=msq(i, j, 0)/2.d0/p45/CF*vv(1, 1, 0, x, z)
      results=results-gaux*pdfsum(i, j)
      apwgt(j+2*(i-1), apNum)=apwgt(j+2*(i-1), apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip013(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p23
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 3, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p23=gdot(p(0, 2), p(0, 3))
      call dipoleCI22(p1, msq, 1)

      gaux=(msq(3, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p23/x/CF*vv(4, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip014(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p23
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 3, 4, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p23=gdot(p(0, 2), p(0, 3))
      call dipoleCI22(p1, msq, 3)

      gaux=(msq(3, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p23/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip015(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p23
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 3, 5, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p23=gdot(p(0, 2), p(0, 3))
      call dipoleCI22(p1, msq, 2)

      gaux=(msq(3, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p23/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip016(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p24
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 4, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p24=gdot(p(0, 2), p(0, 4))
      call dipoleCI22(p1, msq, 1)

      gaux=(msq(2, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p24/x/CF*vv(4, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip017(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p24
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 4, 3, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p24=gdot(p(0, 2), p(0, 4))
      call dipoleCI22(p1, msq, 3)

      gaux=(msq(2, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p24/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip018(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p24
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 4, 5, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p24=gdot(p(0, 2), p(0, 4))
      call dipoleCI22(p1, msq, 2)

      gaux=(msq(2, 1, 0)*(nf-1.d0)+msq(3, 2, 0)/2.d0)
     -      /2.d0/p24/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip019(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 1, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 1)

      gaux=(msq(1, 1, 0)*(nf-1.d0)+msq(1, 2, 0))
     -    /2.d0/p25/x/CF*vv(4, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip020(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 3, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 3)

      gaux=(msq(1, 1, 0)*(nf-1.d0)+msq(1, 2, 0))
     -    /2.d0/p25/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine


      subroutine realdip021(p, results, xxx, yyy)
      implicit none
      integer i, j, cutfactor
      double precision p(0:3, 5), results, CF, p25
      double precision pdfsum(3, 2), msq(3, 2, 0:1), gaux
      double precision x, z, p1(0:3, 4), gdot, vv, xxx, yyy
      parameter (CF=4.d0/3.d0)
      external gdot, vv
      include "var.inc"
      include "appl.inc"
      
      call momtran(2, 5, 4, p, p1, x, z, cutfactor)

      pdfsum=0.d0
      msq=0.d0

      results=0.d0

      if(cutfactor.ge.1) then

      apNum=apNum+1
      call setgpdf(xxx, yyy, pdfsum)


      p25=gdot(p(0, 2), p(0, 5))
      call dipoleCI22(p1, msq, 2)

      gaux=(msq(1, 1, 0)*(nf-1.d0)+msq(1, 2, 0))
     -     /2.d0/p25/x/CF*vv(3, 0, 1, x, z)
      results=results-gaux*pdfsum(3, 1)
      apwgt(5, apNum)=apwgt(5, apNum)+cutfactor*gaux/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale

      results=cutfactor*results

      endif
       
      end subroutine



      double precision function vv(n, i, j, x, z)
c auxiliary functions used in construction of dipole terms  
      implicit none
      integer n ,i, j
      double precision x, z, CF, TR
      parameter (CF=4.d0/3.d0, TR=1.d0/2.d0)
      include "var.inc"

      if(n.eq.1) then

        if((i+j).eq.1) then
      
           vv=8.d0*pi*CF*alfas*(2.d0/(1.d0-z*(1.d0-x))-(1.d0+z))

        else

           print *, "wrong vv function!"
           stop

        endif

      elseif(n.eq.2) then

        if((i+j).eq.1) then
      
           vv=8.d0*pi*CF*alfas*(2.d0/(1.d0-z+(1.d0-x))-(1.d0+z))

        else

           print *, "wrong vv function!"
           stop

        endif

      elseif(n.eq.3) then

        if((i.eq.1).and.(j.eq.0)) then
      
           vv=8.d0*pi*CF*alfas*(2.d0/(1.d0-x+z)-(1.d0+x))

        elseif((i.eq.0).and.(j.eq.1)) then
      
           vv=8.d0*pi*TR*alfas*(1.d0-2.d0*x*(1.d0-x))

        else

           print *, "wrong vv function!"
           stop

        endif

      elseif(n.eq.4) then

        if((i.eq.1).and.(j.eq.0)) then
      
           vv=8.d0*pi*CF*alfas*(2.d0/(1.d0-x)-(1.d0+x))

        elseif((i.eq.0).and.(j.eq.1)) then
      
           vv=8.d0*pi*TR*alfas*(1.d0-2.d0*x*(1.d0-x))

        else

           print *, "wrong vv function!"
           stop

        endif

      else

        print *, "wrong vv function!"
        stop

      endif

      end function
     
