      subroutine intdipi(p, results)
c integrated dipole subtraction terms I (fully factorized)
      implicit none
      integer i, j, k 
      double precision p(0:3, 4), NC, CF, colorsq(3, 2, 0:3), nuq1, nuq2 ,nuq3
      double precision s, t, u, gaq, kq, lgsot, lgsou, gdot, results(2, 2)
      double precision aux(3, 2, 0:1)
      parameter (NC=3.d0, CF=4.d0/3.d0)
      external gdot
      include "var.inc"

      do i=0, 3
      call dipoleCI22(p, aux, i)
      do j=1, 3
      do k=1, 2
      colorsq(j, k, i)=aux(j, k, 0)
      enddo
      enddo
      enddo

      results=0.d0
      
      s=2.d0*gdot(p(0, 1), p(0, 2))
      t=-2.d0*gdot(p(0, 1), p(0, 3))
      u=-2.d0*gdot(p(0, 1), p(0, 4))

      gaq=3.d0*CF/2.d0
      kq=(7.d0/2.d0-pi**2/6.d0)*CF
      lgsot=dlog(-s/t)
      lgsou=dlog(-s/u)
      nuq1=CF*((div**2)-pi**2/3.d0)+gaq*((div)+1.d0)+kq
      nuq2=CF*((div**2+div*lgsot+lgsot**2/2.d0)-pi**2/3.d0)
     -      +gaq*((div+lgsot)+1.d0)+kq
      nuq3=CF*((div**2+div*lgsou+lgsou**2/2.d0)-pi**2/3.d0)
     -      +gaq*((div+lgsou)+1.d0)+kq

      do i=1, 2
      do j=1, 2
      results(i, j)=results(i, j)+2.d0/CF*(2.d0*nuq1*colorsq(i, j, 1)
     -  +2.d0*nuq2*colorsq(i, j, 2)+2.d0*nuq3*colorsq(i, j, 3))
      enddo
      enddo
      
      results=-results*alfas/2.d0/pi

      end subroutine
