      subroutine momtran(i, j, k, pin, pout, x, z, cutfactor)
c 4-momentum transformation functions in dipole real subtraction 
      implicit none
      integer n, i, j, k, cutfactor, new(4), l, naux(2), njet
      double precision pin(0:3, 5), pout(0:3, 4), pij, pik, pjk
      double precision k2, kb2, kt2, coe(2, 2), gmij, QQ(3)
      double precision x, z, gdot, gpt, pjet(0:3, 3)
      external gdot, gpt, gmij
      include "var.inc"

      if(min(i, j).gt.2) then

      if(k.gt.2) then
      n=1
      else
      n=2
      endif

      else

      if(k.gt.2) then
      n=3
      else
      n=4
      endif

      endif
      
      pij=gdot(pin(0, i), pin(0, j))
      pik=gdot(pin(0, i), pin(0, k))
      pjk=gdot(pin(0, j), pin(0, k))

      if(n.eq.1) then ! final-final

      x=pij/(pij+pik+pjk)
      z=pik/(pjk+pik)
      new(1)=1
      new(2)=2
      new(3)=min(i, j)
      new(4)=7-new(3)

      do l=0, 3
      pout(l, new(1))=pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      pout(l, new(3))=pin(l, i)+pin(l, j)-x/(1.d0-x)*pin(l, k)
      pout(l, new(4))=pin(l, k)/(1.d0-x)
      enddo
     
      elseif(n.eq.2) then ! final-initial

      x=(pik+pjk-pij)/(pik+pjk)
      z=pik/(pik+pjk)
      new(1)=k
      new(2)=3-new(1)
      new(3)=min(i, j)
      new(4)=7-new(3)
      
      do l=0, 3
      pout(l, new(1))=x*pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      pout(l, new(3))=pin(l, i)+pin(l, j)-(1.d0-x)*pin(l, k)
      pout(l, new(4))=pin(l, new(4))
      enddo

      elseif(n.eq.3) then ! initial-final

      x=(pik+pij-pjk)/(pik+pij)
      z=pij/(pik+pij)
      new(1)=min(i, j)
      new(2)=3-new(1)
      if(max(i, j).eq.5) then
      new(3)=k
      new(4)=7-new(3)
      do l=0, 3
      pout(l, new(1))=x*pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      pout(l, new(3))=pin(l, max(i, j))+pin(l, k)-(1.d0-x)*pin(l, min(i, j))
      pout(l, new(4))=pin(l, new(4))
      enddo
      elseif(k.eq.5) then
      new(3)=4
      new(4)=3
      do l=0, 3
      pout(l, new(1))=x*pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      pout(l, new(3))=pin(l, max(i, j))+pin(l, k)-(1.d0-x)*pin(l, min(i, j))
      pout(l, new(4))=pin(l, 7-max(i, j))
      enddo
      else
      new(3)=3
      new(4)=4
      do l=0, 3
      pout(l, new(1))=x*pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      pout(l, new(3))=pin(l, max(i, j))+pin(l, k)-(1.d0-x)*pin(l, min(i, j))
      pout(l, new(4))=pin(l, 5)
      enddo
      endif

      elseif(n.eq.4) then ! initial-initial

      x=(pik-pij-pjk)/pik
      z=0.5d0
      new(1)=i
      new(2)=k
      new(3)=3
      new(4)=4
      if(j.eq.5) then
      naux(1)=3
      naux(2)=4
      else
      naux(1)=7-j
      naux(2)=5
      endif
      do l=0, 3
      pout(l, new(1))=x*pin(l, new(1))
      pout(l, new(2))=pin(l, new(2))
      enddo
      k2=2.d0*(gdot(pin(0, 1), pin(0, 2))-gdot(pin(0, 1), pin(0, j))
     -   -gdot(pin(0, 2), pin(0, j)))
      kb2=2.d0*gdot(pout(0, new(1)), pout(0, new(2)))
      kt2=k2+kb2+2.d0*(gdot(pout(0, new(1)), pin(0, 1))
     -     +gdot(pout(0, new(1)), pin(0, 2))
     -     -gdot(pout(0, new(1)), pin(0, j))+gdot(pin(0, 1), pin(0, 2))
     -     -gdot(pin(0, k), pin(0, j)))      

      do l=1, 2
      coe(l, 1)=-2.d0*(gdot(pin(0, naux(l)), pin(0, i))
     -     +2.d0*gdot(pin(0, naux(l)), pin(0, k))
     -     +gdot(pin(0, naux(l)), pout(0, new(1)))
     -     -gdot(pin(0, naux(l)), pin(0, j)))/kt2

      coe(l, 2)=2.d0*(gdot(pin(0, naux(l)), pin(0, i))
     -     +gdot(pin(0, naux(l)), pin(0, k))
     -     -gdot(pin(0, naux(l)), pin(0, j)))/k2
      enddo

      do l=0, 3
      pout(l, new(3))=pin(l, naux(1))+coe(1, 1)*(pin(l, i)+2.d0*pin(l, k)
     -   +pout(l, new(1))-pin(l, j))+coe(1, 2)*(pout(l, new(1))+pin(l, k))
      pout(l, new(4))=pin(l, naux(2))+coe(2, 1)*(pin(l, i)+2.d0*pin(l, k)
     -   +pout(l, new(1))-pin(l, j))+coe(2, 2)*(pout(l, new(1))+pin(l, k))
      enddo

      else
     
      print *, "wrong momentum transform"

      endif

      if((x.lt.0.d0).or.(x.gt.1.d0)) then
      print *, "warning x out of range in real dipole"
      endif

      if((z.lt.0.d0).or.(z.gt.1.d0)) then
      print *, "warning z out of range in real dipole"
      endif

      call jetfind(2, pout, njet, pjet)
      call determinecut(njet, pjet, cutfactor, QQ)

      if(cutfactor.ge.1) then

      facscale=fscale*QQ(1)
      renscale=rscale*QQ(1)

      call setcoupl

      endif

      end subroutine
