      double precision function realint(xxx, yyy, pin)
c returning the sum of 2->3 squared amplitudes from all 3 channels 
      implicit none
      double precision xxx, yyy, pin(0:3, 5), pjet(0:3, 3)
      double precision QQ(3), pdfsum(3, 2), msq(2, 3), aux
      double precision XXPDF(-6:6), YYPDF(-6:6)
      integer i, j, k, njet, cutfactor, pcutfactor
      include "var.inc"
      include "appl.inc"

      call jetfind(3, pin, njet, pjet)
      call determinecut(njet, pjet, cutfactor, QQ)
      pdfsum=0.d0
      aux=0.d0
      realint=0.d0
      pcutfactor=1

      if(cutfactor.ge.1) then

      if((scalescheme.eq.1).and.(ang.eq.4)) pcutfactor=cutfactor

      do i=1, 3

      if(QQ(i).ne.0.d0) then

      apNum=apNum+1
      facscale=fscale*QQ(i)
      renscale=rscale*QQ(i)

      call setcoupl

      call setgpdf(xxx, yyy, pdfsum)

      call calcSunF()

      call qqMatrix(pin, msq(1, 1))
      call qqxMatrix(pin, msq(1, 2))
      call qgMatrix(pin, msq(1, 3))

      do k=1, 3
      do j=1, 2
      aux=aux+pdfsum(k, j)*msq(j, k)
      apwgt(min(j+2*(k-1), 5), apNum)=apwgt(min(j+2*(k-1), 5), apNum)+pcutfactor*msq(j, k)/(alfas**nfac)
      apmuf(apNum)=facscale
      apmur(apNum)=renscale
      enddo
      enddo

      endif

      enddo

      realint=pcutfactor*aux
      
      endif

      end function


      subroutine setgpdf(xxx, yyy, pdfsum)
c calculating all the parton luminosities needed
      implicit none
      double precision xxx, yyy, pdfsum(3, 2)
      double precision XXPDF(-6:6), YYPDF(-6:6)
      integer i, j
      include "var.inc"

      pdfsum=0.d0

      call evolvePDF(xxx, facscale, XXPDF)        
      call evolvePDF(yyy, facscale, YYPDF)
      XXPDF=XXPDF/xxx      
      YYPDF=YYPDF/yyy

      do i=1, 4
      do j=i+1, 5
      pdfsum(1, 1)=pdfsum(1, 1)+(XXPDF(i)*YYPDF(sig*j)
     -    +YYPDF(j)*XXPDF(sig*i)+XXPDF(-i)*YYPDF(-sig*j)
     -    +YYPDF(-j)*XXPDF(-sig*i)) 
      pdfsum(2, 1)=pdfsum(2, 1)+(XXPDF(i)*YYPDF(-sig*j)  
     -    +YYPDF(-j)*XXPDF(sig*i)+XXPDF(j)*YYPDF(-sig*i)
     -    +YYPDF(-i)*XXPDF(sig*j)) 
      enddo
      enddo

      do i=1, 5
      pdfsum(1, 2)=pdfsum(1, 2)+(XXPDF(i)*YYPDF(sig*i)
     -    +XXPDF(-i)*YYPDF(-sig*i)) 
      pdfsum(2, 2)=pdfsum(2, 2)+(XXPDF(i)*YYPDF(-sig*i)
     -    +YYPDF(-i)*XXPDF(sig*i)) 
      pdfsum(3, 1)=pdfsum(3, 1)+(XXPDF(i)*YYPDF(sig*0)
     -    +XXPDF(sig*i)*YYPDF(0)
     -    +XXPDF(-i)*YYPDF(sig*0)+XXPDF(-sig*i)*YYPDF(0)) 
      pdfsum(3, 2)=pdfsum(3, 2)+(XXPDF(i)*YYPDF(sig*0)
     -    +XXPDF(sig*i)*YYPDF(0)
     -    +XXPDF(-i)*YYPDF(sig*0)+XXPDF(-sig*i)*YYPDF(0)) 
      enddo

      end subroutine

